
/*
 *   OpenJupes v1.1
 *
 *   Server and Nickname Jupe Service for Ratbox v2+services.
 *   Copyright (C) 2005 Thomas Carlsson, Joost Vunderink and Alan Milford
 *
 *   NOTE: This service depends heavily on the +services patch by Lee
 *   Hardy. It will not compile without it.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */




/* Define DEFAULT nick, user, host and gecos (used if no conf J-line found) */

#define JUPE_MYNICK         "JUPES"
#define JUPE_MYUSER         "services"
#define JUPE_MYHOST         "services.ratbox"
#define JUPE_MYGECOS            "Ratbox Jupe Service"


/* Configuration */


struct OJ_Conf_Jupes
{
    char    nick[NICKLEN + 1];
    char    user[USERLEN + 1];
    char    host[HOSTLEN + 1];
    char    gecos[IRCLINELEN + 1];
};

struct OJ_Conf_Admins
{
    char    user[USERLEN + 1];
    char    host[HOSTLEN + 1];
    char    server[HOSTLEN + 1];
};

struct OJ_Conf_Ignores
{
    char    server[HOSTLEN + 1];
};

struct OJ_Conf_Nicks
{
    char    nick[NICKLEN + 1];
    char    gecos[IRCLINELEN + 1];
};

struct OJ_Conf
{
    struct OJ_Conf_Jupes    client;

    struct OJ_Conf_Admins*  admin;
    int                     admincount;

    struct OJ_Conf_Ignores* ignore;
    int                     ignorecount;

    struct OJ_Conf_Nicks*   nick;
    int                     nickcount;

    int                     ok;
};


void CONF_Load( struct OJ_Conf* conf );
void CONF_Free( struct OJ_Conf* conf );




int CONF_IsIgnore( struct OJ_Conf* conf, char* server );
int CONF_IsAdmin( struct OJ_Conf* conf, char* user, char* host, char* server );

int CONF_Rehash( struct OJ_Conf* conf );
