
/*
 *   OpenJupes v1.1
 *
 *   Server and Nickname Jupe Service for Ratbox v2+services.
 *   Copyright (C) 2005 Thomas Carlsson, Joost Vunderink and Alan Milford
 *
 *   NOTE: This service depends heavily on the +services patch by Lee
 *   Hardy. It will not compile without it.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */



/* This is lamely here. Should be replaced by an ircd equivalent */
#define IRCLINELEN      512



/* Static defines for memory table sizes */
#define JUPE_HISTORYMAX         10
#define JUPE_NICKJUPESMIN       20
#define JUPE_SERVERJUPESMIN     10



/* Includes */
#include "oj_conf.h"
#include "oj_jupes.h"

struct Service *mainclient_p;

extern struct SVCMessage help_msgtab;
extern struct SVCMessage rehash_msgtab;
extern struct SVCMessage status_msgtab;
extern struct SVCMessage jupe_msgtab;
extern struct SVCMessage dejupe_msgtab;
extern struct SVCMessage history_msgtab;

int s_handle_history(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
int s_handle_help(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
int s_handle_jupe(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
int s_handle_dejupe(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
int s_handle_unjupe(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
int s_handle_status(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
int s_handle_rehash(struct Client *source_p, struct Client *target_p, int parc, const char *parv[]);
void send_command_list(struct Client *target_p);

/* The IRCD Interface Layer */

void OJ_IRCD_BroadcastAllOperators( char* text );
void OJ_IRCD_BroadcastNative( struct IRCD_Data* oper_p, char* text );
void OJ_IRCD_BroadcastSingleOperator( char* oper, char* text );
void OJ_IRCD_BroadcastLocal( char* text );

void OJ_IRCD_CreateFakeClient( struct OJ_nickjupe* nickjupe );
void OJ_IRCD_DeleteFakeClient( struct OJ_nickjupe* nickjupe );

void OJ_IRCD_CreateFakeServer( struct OJ_serverjupe* serverjupe );
void OJ_IRCD_DeleteFakeServer( struct OJ_serverjupe* serverjupe );

#define OJ_MAXPARA 255

#define IRCLINELEN 512

/* Turns a string into an array of strings, separated by <separator>.
 * Example: "for great justice", tokenized with separator ' ', becomes
 * "for", "great" and "justice".
 * The return value is the number of tokens found.
 * By default, the space will be used as separator.
 *
 * Note: if there are more than OCF_MAXPARA tokens, the last token will
 * contain the rest of the string, i.e. all tokens that didn't fit.
 */
int tokenize_string_separator(char *string, char *parv[OJ_MAXPARA], char separator);
int tokenize_string(char *string, char *parv[OJ_MAXPARA]);

